/**
  *  \file planetscentral/host/cmdhost.h
  *  \brief Host: HOST/MASTER commands
  */
#ifndef C2SERVER_PLANETSCENTRAL_HOST_CMDHOST_H
#define C2SERVER_PLANETSCENTRAL_HOST_CMDHOST_H

#include "planetscentral/dbclient/dbsubtree.h"

class HostConnection;
class IntArgBlock;

IntValue* describeHost(const DbSubtree& base, string_t name, bool isDefault);

void doHostAdd(const DbSubtree& base, HostConnection& conn, IntArgBlock& args);
void doHostSet(const DbSubtree& base, HostConnection& conn, IntArgBlock& args);
void doHostGet(const DbSubtree& base, HostConnection& conn, IntArgBlock& args);
void doHostRemove(const DbSubtree& base, HostConnection& conn, IntArgBlock& args);
void doHostList(const DbSubtree& base, HostConnection& conn, IntArgBlock& args);
void doHostCopy(const DbSubtree& base, HostConnection& conn, IntArgBlock& args);
void doHostDefault(const DbSubtree& base, HostConnection& conn, IntArgBlock& args);
void doHostRating(const DbSubtree& base, HostConnection& conn, IntArgBlock& args);

#endif
