/**
  *  \file planetscentral/talk/forum.h
  */
#ifndef C2SERVER_PLANETSCENTRAL_TALK_FORUM_H
#define C2SERVER_PLANETSCENTRAL_TALK_FORUM_H

#include "planetscentral/dbclient/dbclient.h"
#include "planetscentral/dbclient/dbsubtree.h"
#include "int/value.h"

class RenderState;

class Forum {
 public:
    Forum(DbClient& client, int32_t forumId);

    DbHash            header();
    DbHashStringField name();
    DbHashStringField description();
    DbHashStringField readPermissions();
    DbHashStringField writePermissions();
    DbHashStringField answerPermissions();
    DbHashStringField deletePermissions();
    DbHashStringField key();
    DbHashIntField    lastMessageSequenceNumber();
    DbHashIntField    creationTime();
    DbHashIntField    lastPost();
    DbHashIntField    lastTime();

    DbIntSet          messages();
    DbIntSet          topics();
    DbIntSet          stickyTopics();
    DbStringSet       watchers();

    void              setParent(string_t newParent);
    string_t          getParent();

    void              setNewsgroup(string_t newNG);
    string_t          getNewsgroup();

    int32_t           getId() const;
    static int32_t    allocateForum(DbClient& client);

    bool              exists();

    IntValue*         describe(RenderState& state);
    IntValue*         describeAsNewsgroup(RenderState& state);

 private:
    DbSubtree forum;
    int32_t forumId;
};

int32_t getTime();

#endif
